#delimit ;
discard;
clear;

set mem 200m;
set more off;

log using c:\prosjekt_work\event_history_course\exercise1.log, replace;

use c:\prosjekt_work\event_history_course\sample_data1.dta, clear;

describe;

list in 1/10;

summarize;

gen sex=1 if gender=="male";
replace sex=0 if gender=="female";

/* alternative 
gen sex=gender=="male";
*/

gen lnwage=ln(wage);

summarize lnwage;

sort id;

save c:\prosjekt_work\event_history_course\sample_data1_mod.dta, replace;

use c:\prosjekt_work\event_history_course\sample_data2.dta, clear;

sort id;

joinby id using c:\prosjekt_work\event_history_course\sample_data1_mod.dta, unmatched(both);

drop if lnwage==. | taxgain==.;

summarize;

gen edu1=edu_years <=9; 

gen edu2=edu_years <=12 & edu_years >=10;

gen edu3=edu_years >=13 & edu_year ~=. ;/* WATCH OUT for missing value */

/* note taxgain has negative values, cannot use log to rescale.*/

replace taxgain=taxgain/1000;

regress lnwage sex edu1 edu3;

predict lnw_pred, xb;

sum lnwage lnw_pred;

logit op sex edu1 edu3 lnwage taxgain;

log close;
