#delimit ;
discard;
clear;

set mem 200m;
set more off;

log using C:\prosjekt_work\event_history_course\exercises\exercise2.log, replace;

use C:\prosjekt_work\event_history_course\exercises\continous_weibull.dta, clear;

des;

sum;


/* alternatively, if we use start stop 

stset stop, origin(start) failure(d) id(id);

*/


gen yy=y>=0;

sort yy;

by yy: sum;

stset t, failure(d) id(id);

sts;

graph save  C:\prosjekt_work\event_history_course\exercises\continous_weibull_km_surv.gph, replace;


sts, hazard;

graph save  C:\prosjekt_work\event_history_course\exercises\continous_weibull_km_haz.gph, replace;

sts, by(yy);

graph save  C:\prosjekt_work\event_history_course\exercises\continous_weibull_km_surv_by_y.gph, replace;


sts list;

sts graph, hazard;


ltable t d;

ltable t d, hazard;

ltable t d, graph saving(C:\prosjekt_work\event_history_course\exercises\continous_weibull_lt.gph, replace);


/* constant hazard exponential distribution */

use C:\prosjekt_work\event_history_course\exercises\constant_hazard.dta, clear;

des;

sum;


/* alternatively, if we use start stop 

stset stop, origin(start) failure(d) id(id);

*/

gen yy=y>=0;

sort yy;

by yy: sum;

stset t, failure(d) id(id);

sts;

graph save  C:\prosjekt_work\event_history_course\exercises\constant_hazard_km_surv.gph, replace;

sts, by(yy);

graph save  C:\prosjekt_work\event_history_course\exercises\constant_hazard_km_surv_by_y.gph, replace;


sts, hazard;

graph save  C:\prosjekt_work\event_history_course\exercises\constant_hazard_km_haz.gph, replace;

sts list;

sts graph, hazard;


ltable t d;

ltable t d, hazard;

ltable t d, graph saving(C:\prosjekt_work\event_history_course\exercises\constant_hazard_lt.gph, replace);


/* episode splitting */

use C:\prosjekt_work\event_history_course\exercises\continous_weibull.dta, clear;

des; sum;

stset t, failure(d) id(id);

stsplit splitid, at(1) ;

replace d=0 if d==.; /* or we could based on splitid, replace d=0 if splitid==0; */

replace x=x2 if splitid==1; /* change x value for subspell 1*/

stset t, failure(d) id(id);

sum;

log close;