#delimit ;
discard;
clear;

set mem 200m;
set more off;

log using C:\temp\event\exercise4.log, replace;

use C:\temp\event\discrete_weibull.dta, clear;

des;

sum;

/* duplicate observations based on discrete t */

expand t;

sort id;

/* generate subspell id, note epid[_n]-epid[_n-1]=1 is the subspell length */
by id: gen epid=_n;

/* censor all subspells except last one */
by id: replace d=0 if _n != _N;

/* create dummy variables for indicator of subspells */
tabulate epid, gen(dur);

list id d epid dur1-dur12 in 1/5;

tab epid d;


cloglog d x y dur2-dur12;

cloglog d x y dur1-dur12, nocons;

/* misspecificated model estimation */

logit d x y dur1-dur12, nocons;

/* on splitted data */

stset epid, id(id) failure(d);

sts;

sts, hazard;

stcox x y, nohr;

streg x y, dist(weibull) nohr;

/* on original data */

use C:\temp\event\discrete_weibull.dta, clear;

stset t, id(id) failure(d);

stcox x y, nohr;

streg x y, dist(weibull) nohr;

log close;

