#delimit ;
discard;
clear;

set mem 200m;
set more off;

capture program drop _all;

/* simulation */

set obs 2000;
gen id=_n;


gen x=invnormal(uniform());
gen y=invnormal(uniform());

/*no uobs
gen v=0.6475*invgammap(1/0.6475,uniform()); 
*/

/* gammap(a, b), gammaden(a,b,g,x)=gammap(a,(x-g)/b). so invgammap(a,p) should be 
equivalent as x=b*invgammap(a,p)+g. set g=0, a=1/theta=1/b, b=theta in estimation, which means E(x)=1,
Var(x)=theta=b. 
we simulate v in gamma distribution, and ln(v) is used in exp()
*/

/* the b# here is log form of the intergrated weibull baseline for interval [d-1, d] where d=1-12, that is the first 12 month
of weibull distributed baseline, with scale parameter 0.9, shape parameter 1 */

gen b1=0;
gen b2=-0.14379418;
gen b3=-0.196246789;
gen b4=-0.230260223;
gen b5=-0.255541029;
gen b6=-0.275683412;
gen b7=-0.292432048;
gen b8=-0.306769221;
gen b9=-0.319303625;
gen b10=-0.330438866;
gen b11=-0.340456439;
gen b12=-0.349560542;

/* c# is log form for weibull baseline in [d-1,d], with shape=0.9, scale=1 */
gen c1=  0;
gen c2=  0.260359726;
gen c3=  0.364501512;
gen c4=  0.432326959;
gen c5=  0.482806734;
gen c6=  0.523050305;
gen c7=  0.556523953;
gen c8=  0.585183502;
gen c9=  0.610242432;
gen c10= 0.632505993;
gen c11= 0.652536103;
gen c12= 0.670740529;




expand 12;
sort id;

gen bs=.;
gen cs=.;
by id: replace bs=b1 if _n==1;
by id: replace bs=b2 if _n==2;
by id: replace bs=b3 if _n==3;
by id: replace bs=b4 if _n==4;
by id: replace bs=b5 if _n==5;
by id: replace bs=b6 if _n==6;
by id: replace bs=b7 if _n==7;
by id: replace bs=b8 if _n==8;
by id: replace bs=b9 if _n==9;
by id: replace bs=b10 if _n==10;
by id: replace bs=b11 if _n==11;
by id: replace bs=b12 if _n==12;


by id: replace cs=c1 if _n==1;
by id: replace cs=c2 if _n==2;
by id: replace cs=c3 if _n==3;
by id: replace cs=c4 if _n==4;
by id: replace cs=c5 if _n==5;
by id: replace cs=c6 if _n==6;
by id: replace cs=c7 if _n==7;
by id: replace cs=c8 if _n==8;
by id: replace cs=c9 if _n==9;
by id: replace cs=c10 if _n==10;
by id: replace cs=c11 if _n==11;
by id: replace cs=c12 if _n==12;


drop b1-b12 c1-c12;

gen haz1=exp(bs+x+(-1)*y-2.696159046);
gen haz2=exp(cs-x+(+1)*y-3.594878728);
gen u1=uniform();
gen u2=uniform();

gen d=0;
replace d=1 if (1-exp(-haz1-haz2)) >=u1; /* probability for event happens, I will replace d=1 with 2 below 
for transitions to 2 */


by id: replace d=. if d[_n-1] ==1; /* spell should end when there is an event d */

by id: replace d=. if d[_n-1]==. & _n>1; /* avoid d[_n-1]=. when _n==1 */

drop if d==.;

replace d=2 if (1-exp(-haz1-haz2)) >= u1 & haz1/(haz1+haz2) < u2; /* event 2 */

sort id;

by id: gen t=_n if _n==_N;
by id: gen keep=1 if _n==_N;

keep if keep==1;

keep id t d x y;

save C:\prosjekt_work\event_history_course\exercises\competing_risk_discrete_weibull.dta, replace;





