#delimit ;
discard;
clear;

set mem 200m;
set more off;

/* simulation */

set obs 200;
gen id=_n;



*set seed 569821764;

gen x=invnormal(uniform());
*gen y=uniform()<=0.6;
gen y=invnormal(uniform());

*gen v=0.6475*invgammap(1/0.6475,uniform());

/* gammap(a, b), gammaden(a,b,g,x)=gammap(a,(x-g)/b). so invgammap(a,p) should be 
equivalent as x=b*invgammap(a,p)+g. set g=0, a=1/theta=1/b, b=theta in estimation, which means E(x)=1,
Var(x)=theta=b. 
we simulate v in gamma distribution, and ln(v) is used in exp()
*/


/* weibull1 shape=0.9, scale=1 
   weibull2 shape=1.2, scale=1
 */




gen t1=(-ln(1-uniform()))^(1/0.9)/((exp(x+(-1)*y))^(1/0.9));

gen t2=(-ln(1-uniform()))^(1/1.2)/((exp(-x+y))^(1/1.2));


/* the actual transition depends on min(t1,t2), and code d=1,2 no censoring for this data*/

gen d=1 if t1 <=t2;
replace d=2 if t1>t2;

/* t is the observed duraiton. */

gen t=min(t1, t2);


save C:\prosjekt_work\event_history_course\exercises\competing_risk_weibull.dta, replace;

stset t, failure(d==1) id(id);
streg x y, dist(w) nohr ;

stset t, failure(d==2) id(id);
streg x y, dist(w) nohr ;

