#delimit ;
discard;
clear;

set mem 200m;
set more off;


/* simulation */

set obs 200;
gen id=_n;


gen x=invnormal(uniform());
gen y=invnormal(uniform());
gen v=0.6475*invgammap(1/0.6475,uniform()); 



/* gammap(a, b), gammaden(a,b,g,x)=gammap(a,(x-g)/b). so invgammap(a,p) should be 
equivalent as x=b*invgammap(a,p)+g. set g=0, a=1/theta=1/b, b=theta in estimation, which means E(x)=1,
Var(x)=theta=b. 
we simulate v in gamma distribution, and ln(v) is used in exp()
*/

/* the b# here is log form of the intergrated weibull baseline for interval [d-1, d] where d=1-12, that is the first 12 month
of weibull distributed baseline, with scale parameter 0.9, shape parameter 1 */

gen b1=0;
gen b2=-0.14379418;
gen b3=-0.196246789;
gen b4=-0.230260223;
gen b5=-0.255541029;
gen b6=-0.275683412;
gen b7=-0.292432048;
gen b8=-0.306769221;
gen b9=-0.319303625;
gen b10=-0.330438866;
gen b11=-0.340456439;
gen b12=-0.349560542;

expand 12;
sort id;

gen bs=.;
by id: replace bs=b1 if _n==1;
by id: replace bs=b2 if _n==2;
by id: replace bs=b3 if _n==3;
by id: replace bs=b4 if _n==4;
by id: replace bs=b5 if _n==5;
by id: replace bs=b6 if _n==6;
by id: replace bs=b7 if _n==7;
by id: replace bs=b8 if _n==8;
by id: replace bs=b9 if _n==9;
by id: replace bs=b10 if _n==10;
by id: replace bs=b11 if _n==11;
by id: replace bs=b12 if _n==12;


drop b1-b12;

gen haz=1-exp(-exp(bs+x+(-1)*y-2.072326584+ln(v)));

by id: gen d=uniform() <=haz;
by id: replace d=. if d[_n-1]==1;

by id: replace d=. if d[_n-1]==. & _n>1;


drop if d==.;

sort id;

by id: gen t=_n if _n==_N;
by id: gen keep=1 if _n==_N;

keep if keep==1;

keep id t d x y;

save C:\prosjekt_work\event_history_course\exercises\discrete_weibull_with_uobs.dta, replace;


expand t;

sort id;

by id: replace d=0 if _n ~= _N;

by id: gen epid=_n;

tab epid, gen(dur);

cloglog d x y dur2-dur12;

pgmhaz x y dur2-dur12, id(id) dead(d) seq(epid);




