#delimit ;
discard;
clear;

set mem 200m;
set more off;

/* simulation */

set obs 200;
gen id=_n;



*set seed 569821764;

gen x=invnormal(uniform());
*gen y=uniform()<=0.6; /* example of simulate y as dummy with P(y=1)=0.6 */
gen y=invnormal(uniform());

gen v=0.6475*invgammap(1/0.6475,uniform());

/* gammap(a, b), gammaden(a,b,g,x)=gammap(a,(x-g)/b). so invgammap(a,p) should be 
equivalent as x=b*invgammap(a,p)+g. set g=0, a=1/theta=1/b, b=theta in estimation, which means E(x)=1,
Var(x)=theta=b. 
we simulate v in gamma distribution, and ln(v) is used in exp()
*/


/* here is the example with scale parameter 0.1
gen t=(-ln(1-uniform()))^(1/0.9)/(0.1*(exp(x))^(1/0.9));

gen t_uobs=(-ln(1-uniform()))^(1/0.9)/(0.1*(exp(x+ln(v)))^(1/0.9));


gen haz=(0.1^0.9)*0.9*t^(-0.1)*exp(x);

gen haz_uobs=(0.1^0.9)*0.9*t^(-0.1)*exp(x+ln(v));
*/


/* weibull shape=0.9, scale=1  */

gen t=(-ln(1-uniform()))^(1/0.9)/((exp(x+(-1)*y))^(1/0.9));

gen t_uobs=(-ln(1-uniform()))^(1/0.9)/((exp(x+(-1)*y+ln(v)))^(1/0.9)); /* with unobserved heterogeneity */


gen haz=0.9*t^(-0.1)*exp(x+(-1)*y);

gen surv=exp(-t^0.9*exp(x+(-1)*y));

gen haz_uobs=0.9*t^(-0.1)*exp(x+(-1)*y+ln(v)); 

gen surv_uobs=exp(-t^0.9*exp(x+(-1)*y+ln(v)));



/* if no censoring everyone has transition d=1. censor at t=30*/

gen d=1;
replace d=0 if t>30;
replace t=30 if t > 30;

gen d_uobs=1;
replace d_uobs=0 if t_uobs >30;
replace t_uobs=30 if t_uobs > 30;


gen start=int(1+(12-1+1)*uniform()); /* only for dur without uobs */

gen stop=start+t;

/* generate a time-varying x, at random time of duration */

sum t, detail ;
gen t_vary=r(min)+(t-r(min))*uniform(); /* this is not used in exercise. just a random time point 
for splitting episode, how do we do that? */

gen x2=invnormal(uniform());

save C:\prosjekt_work\event_history_course\exercises\continous_weibull.dta, replace;

stset t, failure(d) id(id);

sts;

stcox x y, nohr;

stcox x y, nohr frailty(gamma) shared(id);

streg x y, nohr dist(weibull) ;

streg x y, nohr dist(weibull)  frailty(gamma);

